#! /bin/csh -f
#
# $Id: earch.csh,v 1.1 2007-01-13 19:06:36+09 shige Exp shige $
# Ѳǡ/ csh ץ
# shige
# earch.csh
#
# 1)	ϡǾȿ ($minhz) ȿ ($maxhz) ο 
#	($middle) Ϥơ$middle  $minhz ءȿ
#	(Ū) $div Ĥʬ䤷γưδֳ֤餫
#	åɤƲ $div ĤβǡƱͤˡ
#	$middle  $maxhz ؤ $div ĤΥǡ (ĹϤ줾 3
#	$sndlen ߥ) 롣
# 2)	ƥǡˤϡ
#	[a] ξβ 
#	[b] Ʊ򺸤
#	[c] Ʊ򱦤
#	 3 Ĥ줾 $sndlen ߥäƤ롣
#
##########  ##########

##### /̤ ##### 
###
### $minhz, $maxhz: Ǿ/ȿ (default: 20Hz ~ 20kHz)
### $snddir: ƥݥեǥ쥯ȥ
### $form  : եޥå (wav, aiff Τ줫)
### $div   : ʬ = 徺ߤ줾Ǻ벻ǡθĿ
###          ($div = 30 ΤȤϲˤ 1 Ĥ)
###
set minhz = 20
set maxhz = 20000
set snddir = snd
set form = wav
set div = 30
###
### $awk: GNU awk (ѥ̤äƤʤϥեѥ)
### $bc : bc 
###
set awk = awk
set bc = bc
###
### $mydebug  : 1 ΤȤϡºݤˤϲκ/Ϥʤ
### $myverbose: 1 ΤȤϡޥɥ饤̽
###
set mydebug = 0
set myverbose = 1

##### Ѥ ##### 
###
### $sndplay: ե ("$sndplay [ե]" ǺǤ)
###
set sndplay = waveplay

##### Ѥ ##### 
###
### $sndglis : sndglis إѥ̤äƤʤȤϤؤΥեѥ
### $sndchmix: sndchmix إѥ̤äƤʤȤϤؤΥեѥ
### $sndconn : WAV  wavconn (ɬפʤեѥ)
###          : AIFF  aiffconn (ɬפʤեѥ)
### $glisop  : sndglis ؤΥץ (ץ󥰼ȿʳϥǥե
###            ȤΤޤޤ˾ޤ)
### $vlebel  : Υܥ塼٥ (0.0 ~ 1.0 δ)
### $sndlen  : ƲʬĹ (ߥ)
### $splen   : ǸˤĤ̵ʬĹ (ߥ)
###
set sndglis = sndglis
set sndchmix = sndchmix
set sndconn = ${form}conn
set glisop = "-$form -c2 -b16 -s44100"
set vlevel = 0.7
set sndlen = 1000
set splen = 1000

########## ¹ʬ ##########
set middle = `echo "sqrt(${minhz}*${maxhz})" | $bc -l`
set numlen = 7
set tmpf = $snddir/tmpf
set play = 1

if ( $#argv < 1 ) then
usage:
#    echo "Usage: csh -f `basename $0` {up|down} (makesound)"
    echo "Usage: csh -f `basename $0` {up|down}"
    echo "    up  : 徺"
    echo "    down: "
#    echo "    makesound: ꤷΤ߲κ"
    exit
endif
if ( "X$argv[1]" == "Xup" ) then
    set m1=$middle
    set m2=$maxhz
    set fhead = "$snddir/u-"
else if ( "X$argv[1]" == "Xdown" ) then
    set m1=$middle
    set m2=$minhz
    set fhead = "$snddir/d-"
else
    goto usage
endif
if ( $#argv > 1 ) then
    if ( "X$argv[2]" == "Xmakesound" ) then
	set play = 0
    else
	goto usage
    endif
endif

########## ¹ʬ֥롼 ##########
###
### $m1,$m2: $m1 Hz  $m2 Hz  $div ʬβ/
### $fhead : ǡեƬˤĤե̾ 
###          (${fhead}[ֹ].$form Ȥեˤʤ)
###
run:
if ( ! -d $snddir ) then
    echo "ǥ쥯ȥ $snddir ߤĤޤ"
    exit
endif
if ( ! $play ) then
    set tmps1 = $snddir/tmpf1.$form
    set tmps2 = $snddir/tmpf2.$form
    set tmps3 = $snddir/tmpf3.$form
    set tmps4 = $snddir/tmpf4.$form
endif

$awk -v d=$div -v m=$m1 -v M=$m2 'BEGIN{ x=log(M/m)/d; \
    printf "%.16f %.3f\n",exp(x),12*x/log(2)}' > $tmpf
set fac = `$awk '{print $1}' $tmpf`
set num = `$awk '{print $2}' $tmpf`
if ( $myverbose ) then
    echo "1 ĤΥǡ (ȿѰ) = $fac (Ⱦ $num ʬ)"
endif

set x = $m1
set j = 1
set lastj = $div
while ( $j <= $lastj )
    set y = `echo "${x}*$fac" | $bc -l`
    # $x Hz  $y Hz ؤΥåɲ
    # ưη $nlen 
    set px = `echo $x | $awk -v nlen=$numlen '{print substr($1,1,nlen)}'`
    set py = `echo $y | $awk -v nlen=$numlen '{print substr($1,1,nlen)}'`
    set n = `printf "%02d" $j`
    if ( $play ) then
	#####  #####
	if ( $myverbose ) then
	    echo "[$n] [${px}Hz ~ ${py}Hz]"
	endif
	if ( $mydebug ) then
	    echo "$sndplay $fhead$n.$form"
	else
	    $sndplay $fhead$n.$form
	endif
    else
        #####  #####
	# $tmps1: (default Ǥ) 2ch Υåɲ
	# $tmps2: ͥΤߤΥåɲ
	# $tmps3: ͥΤߤΥåɲ
        # $tmps4: ̵
	# ¤٤ƤĤʤ
	if ( $myverbose ) then
	    echo "$sndglis $glisop -v$vlevel $px $py $sndlen > $tmps1"
	    echo "$sndchmix 1: $tmps1 > $tmps2"
	    echo "$sndchmix :1 $tmps1 > $tmps3"
	    echo "$sndglis $glisop -v0 $px $py $splen > $tmps4"
	    echo "$sndconn $tmps1 $tmps2 $tmps3 $tmps4 > $fhead$n.$form"
	endif
	if ( ! $mydebug ) then
	    $sndglis $glisop -v$vlevel $px $py $sndlen > $tmps1
	    $sndchmix 1: $tmps1 > $tmps2
	    $sndchmix :1 $tmps1 > $tmps3
	    $sndglis $glisop -v0 $px $py $splen > $tmps4
	    $sndconn $tmps1 $tmps2 $tmps3 $tmps4 > $fhead$n.$form
	endif
    endif
    set x = $y
    @ j ++
end
